/*
 *  Config.h -- misc defines
 *
 *  Config.h is a part of binkd project
 *
 *  Copyright (C) 1996  Dima Maloff, 5047/13
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version. See COPYING.
 */

/* $Id: Config.h,v 1.4 1996/12/29 09:21:09 mff Exp $ */

#ifndef _Config_h
#define _Config_h

#ifdef __WATCOMC__
#include <direct.h>
#define MAXPATHLEN NAME_MAX
#elif defined (VISUALCPP)
#include <direct.h>
#define MAXPATHLEN _MAX_PATH
#else
#include <sys/param.h>
#endif


/* Please, no spaces here! */
#define PRTCLNAME "binkp"
#define PRTCLVER "1.0"
#define MYNAME "binkd"
#define _MYVER "0.8.5"
#ifdef USE_SOCKS
#define MYVER _MYVER"/SOCKS"
#else
#define MYVER _MYVER
#endif

/* Enveronment */
#define MAX_ENV_VAR_NAME 256
#if defined(OS2) || defined(NT) || defined(W95)
#define PATH_SEPARATOR "\\"
#else
#define PATH_SEPARATOR "/"
#endif

/* Protocol */
#define DEF_PORT 24554
#define DEF_TIMEOUT (5*60)
#define MAX_LINES_BEFORE_LOGIN 50
#define MIN_BLKSIZE 512
#define MAX_BLKSIZE (32*1024u)		    /* Don't change! */
#define DEF_BLKSIZE (4*1024u)
#define MAX_NETNAME 255

/* System... */
#define STACKSIZE (128*1024)
#ifndef O_BINARY
#define O_BINARY 0
#endif
#if defined(__WATCOMC__) || defined(VISUALCPP)
#define MKDIR(s) mkdir(s)
#else
#define MKDIR(s) mkdir(s, 0755)
#endif
#ifndef OS
#if defined(NT)
#define OS "NT"
#elif defined(W95)
#define OS "Win95"
#elif defined(OS2)
#define OS "OS2"
#endif
#endif

/* Pragmas */
#ifdef __WATCOMC__
#pragma off (unreferenced);
#endif

#endif
