/*
 *  binkd.c -- binkd's main
 *
 *  binkd.c is a part of binkd project
 *
 *  Copyright (C) 1996  Dima Maloff, 5047/13
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version. See COPYING.
 */

/*
 *  $Id: binkd.c,v 1.6 1996/12/29 09:22:49 mff Exp mff $
 *
 *  $Log: binkd.c,v $
 * Revision 1.6  1996/12/29  09:22:49  mff
 * Misc changes
 *
 * Revision 1.5  1996/12/14  07:00:32  mff
 * Now we use branch() and set_break_handlers()
 *
 * Revision 1.3  1996/12/07  12:26:37  mff
 * SOCKS support by msh
 *
 * Revision 1.1.1 1996/12/02  18:26:00  ufm
 *    Port to NT
 */

#include <string.h>
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>

#include "Config.h"
#include "sys.h"
#include "iphdr.h"
#include "readcfg.h"
#include "server.h"
#include "client.h"
#include "tools.h"
#include "bsy.h"

#ifdef USE_SOCKS
#include "socks.h"
#endif

/*
 * Global variables
 */
int pidcmgr = 0;			    /* pid for clientmgr */

#ifdef HAVE_FORK

static void chld (int signo)
{
  int pid = -1;

  wait (&pid);
#ifdef EMX
  signal (signo, SIG_ACK);
#endif
}

#endif

int main (int argc, char *argv[])
{
  if (argc < 2)
  {
    printf ("usage: %s config\n", argv[0]);
    exit (1);
  }

  readcfg (argv[1]);
  Log (4, "BEGIN, " MYNAME "/" MYVER);
  if (sock_init ())
    Log (0, "sock_init: %s", TCPERR ());
  bsy_init ();
  rnd ();
  /* Set up break handler, set up exit list if needed */
  if (!set_break_handlers ())
    Log (0, "cannot install break handlers");

#ifdef HAVE_FORK
  signal (SIGCHLD, chld);
#endif

  if ((pidcmgr = branch (clientmgr, 0)) < 0)
  {
    Log (0, "cannot branch out");
  }
  else
  {
    Log (4, "started clientmgr, id=%i", pidcmgr);
  }
  servmgr (0);

  return 0;
}
