/*
 *  branch.c -- Create co-processes
 *
 *  branch.c is a part of binkd project
 *
 *  Copyright (C) 1996  Dima Maloff, 5047/13
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version. See COPYING.
 */

/*
 * $Id: branch.c,v 1.2 1996/12/29 09:37:30 mff Exp mff $
 *
 * $Log: branch.c,v $
 * Revision 1.2  1996/12/29  09:37:30  mff
 * Misc changes
 *
 * Revision 1.1  1996/12/14  07:01:58  mff
 * Initial revision
 *
 */
#include <string.h>
#include <stdlib.h>
#include <errno.h>

#ifdef HAVE_FORK
#include <unistd.h>
#elif defined(HAVE_THREADS)
#include <dos.h>
#include <process.h>
#else
#error Must define either HAVE_FORK or HAVE_THREADS!
#endif

#include "Config.h"
#include "sys.h"
#include "tools.h"

int branch (void (*F) (void *), void *arg)
{
  int rc;

#ifdef HAVE_FORK
  if (!(rc = fork ()))
  {
    F (arg);
    exit (0);
  }
  else if (rc < 0)
  {
    Log (1, "fork: %s", strerror (errno));
  }
#endif

#ifdef HAVE_THREADS
#if defined(NT) || defined(W95)
/*
HANDLE Hnd;
DWORD ID;
   Hnd = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)F,arg,0,&ID);
   rc = (-1);
   if (Hnd == NULL) {
      Log (1, "CreateThread: %s",strerror (GetLastError));
   } else {
      CloseHandle(Hnd);
      rc = (int) ID;
   }
*/
  if ((rc = _beginthread (F, 0, STACKSIZE, arg)) < 0)
  {
    Log (1, "_beginthread: %s", strerror (errno));
  }
#elif defined(OS2)
  if ((rc = _beginthread (F, 0, STACKSIZE, arg)) < 0)
  {
    Log (1, "_beginthread: %s", strerror (errno));
  }
#endif
#endif

  return rc;
}
