/*
 * You must be VERY CAREFUL with this module. Note, this
 * code is working in VERY diff. ways in forking vs. threading versions!!
 */
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include <errno.h>
#ifdef HAVE_UNISTD
#include <unistd.h>
#endif
#ifdef HAVE_IOH
#include <io.h>
#endif

#include "Config.h"
#include "ftnaddr.h"
#include "bsy.h"
#include "tools.h"
#include "sem.h"

#ifdef HAVE_THREADS
static MUTEXSEM sem = 0;

#endif

typedef struct _BSY_ADDR BSY_ADDR;
struct _BSY_ADDR
{
  BSY_ADDR *next;
  FTN_ADDR fa;
};

BSY_ADDR *bsy_list = 0;

void bsy_init ()
{
  InitSem (&sem);
}

void bsy_deinit ()
{
  CleanSem (&sem);
}

static BSY_ADDR *bsy_get_free_cell ()
{
  BSY_ADDR *lst;

  for (lst = bsy_list; lst; lst = lst->next)
    if (FA_ISNULL (&lst->fa))
      break;
  if (!lst)
  {
    lst = malloc (sizeof (BSY_ADDR));
    assert (lst != 0);
    FA_ZERO (&lst->fa);
    lst->next = bsy_list;
    bsy_list = lst;
  }
  return lst;
}

/*
 * 1 -- ok, 0 -- failed
 */
int bsy_add (FTN_ADDR *fa0)
{
  char buf[MAXPATHLEN + 1];
  int ok = 0;

  ftnaddress_to_filename (buf, fa0);

  LockSem (&sem);
  if (*buf)
  {
    strnzcat (buf, ".bsy", sizeof (buf));
    if (mkpath (buf) == -1)
      Log (1, "mkpath: %s", strerror (errno));

    if (create_sem_file (buf))
    {
      BSY_ADDR *new_bsy = bsy_get_free_cell ();

      memcpy (&new_bsy->fa, fa0, sizeof (FTN_ADDR));

      ok = 1;
    }
  }
  ReleaseSem (&sem);
  return ok;
}

void bsy_remove (FTN_ADDR *fa0)
{
  char buf[MAXPATHLEN + 1];
  BSY_ADDR *bsy;

  ftnaddress_to_filename (buf, fa0);
  if (*buf)
  {
    strnzcat (buf, ".bsy", sizeof (buf));

    LockSem (&sem);
    for (bsy = bsy_list; bsy; bsy = bsy->next)
    {
      if (!ftnaddress_cmp (&bsy->fa, fa0))
      {
	if (unlink (buf) == -1)
	  Log (1, "cannot unlink `%s': %s", buf, strerror (errno));
	else
	  Log (5, "unlinked %s", buf);
	FA_ZERO (&bsy->fa);
	break;
      }
    }
    ReleaseSem (&sem);
  }
}

/*
 * For exitlist...
 */
void bsy_remove_all ()
{
  char buf[MAXPATHLEN + 1];
  BSY_ADDR *bsy;

  for (bsy = bsy_list; bsy; bsy = bsy->next)
  {
    ftnaddress_to_filename (buf, &bsy->fa);
    if (*buf)
    {
      strnzcat (buf, ".bsy", sizeof (buf));
      if (unlink (buf) == -1)
	Log (1, "cannot unlink `%s': %s", buf, strerror (errno));
      else
	Log (5, "unlinked %s", buf);
      FA_ZERO (&bsy->fa);
    }
  }
  bsy_deinit ();
}
