/*
 *  ftnnode.h -- Handle our links
 *
 *  ftnnode.h is a part of binkd project
 *
 *  Copyright (C) 1996  Dima Maloff, 5047/13
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version. See COPYING.
 */

/*
 * $Id: ftnnode.h,v 1.1 1996/12/29 09:41:45 mff Exp mff $
 *
 * $Log: ftnnode.h,v $
 * Revision 1.1  1996/12/29  09:41:45  mff
 * Initial revision
 *
 */
#ifndef _ftnnode_h
#define _ftnnode_h

#include "Config.h"
#include "ftnaddr.h"
#include "iphdr.h"

#define MAXPWDLEN 40

typedef struct _FTN_NODE FTN_NODE;
struct _FTN_NODE
{
  FTN_ADDR fa;
  char host[MAXHOSTNAMELEN + 1];
  unsigned short port;
  char pwd[MAXPWDLEN + 1];
  char filebox[MAXPATHLEN + 1];
};

extern int nNod;
extern FTN_NODE *pNod;

/*
 * Return up/downlink info by fidoaddress. 0 == node not found
 */
FTN_NODE *get_node_info (FTN_ADDR *fa);

/*
 * Compares to nodes. 0 == don't match
 */
int node_cmp (FTN_NODE *a, FTN_NODE *b);

#endif
