/*
 *  ftnq.h -- BSO interface
 *
 *  ftnq.h is a part of binkd project
 *
 *  Copyright (C) 1996  Dima Maloff, 5047/13
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version. See COPYING.
 */

/* $Id: ftnq.h,v 1.3 1996/12/29 09:42:49 mff Exp mff $

 * $Log: ftnq.h,v $
 * Revision 1.3  1996/12/29  09:42:49  mff
 * Misc changes
 *
 * Revision 1.2  1996/12/14  07:04:39  mff
 * Addedd q_scan_addrs()
 *
 * Revision 1.2  1996/12/04  04:05:31  mff
 * The stable one
 */
#ifndef _ftnq_h
#define _ftnq_h

#if !defined(NT) && !defined(W95)
#include <sys/time.h>
#endif

#include "Config.h"
#include "ftnaddr.h"
#include "readcfg.h"

typedef struct _FTNQ FTNQ;
struct _FTNQ
{
  FTNQ *next;
  FTNQ *prev;

  FTN_ADDR fa;
  char flvr;				    /* 'I', 'i', 'C', 'c', 'D', 'd', *
					     * 'O', 'o', 'F', 'f', 'H', 'h' */
  char action;				    /* 'd'elete, 't'runcate, '\0' -- *
					     * none */
  char type;				    /* 'm'ail (.out), .f'l'o, '*' -- *
					     * a file from .flo (just for *
					     * stats, it will never be *
					     * selected for sending right *
					     * from the queue, it will be *
					     * send when parsing its .flo *
					     * instead, now it's obsolete), *
					     * other -- a file to send. */
  char path[MAXPATHLEN + 1];
  unsigned long size;
  time_t time;
  int sent;				    /* == 0, if the file have been
					     * sent */
};

/*
 * Scans outbound. Return value must be q_free()'d.
 */
FTNQ *q_scan ();
void q_free (FTNQ *q);

/*
 * Adds to the q all files for n akas stored in fa
 */
FTNQ *q_scan_addrs (FTNQ *q, FTN_ADDR *fa, int n);

/*
 * Selects a node to make the next call. Returns a field in q, or
 * 0 if the queue is empty. Subsequent call on the same q will return
 * another node.
 */
FTN_NODE *q_next_node (FTNQ *q);

/*
 * Selects from q the next file for fa (Returns a pointer to a q element)
 */
FTNQ *select_next_file (FTNQ *q, FTN_ADDR *fa, int nAka);

/*
 * Just lists q, not more
 */
void q_list (FILE *out, FTNQ *q);

/*
 * Creates an empty .?lo
 */
int create_poll (FTN_ADDR *fa, int flvr);

#define FQ_ZERO(x) (memset(x, 0, sizeof(*(x))), FA_ZERO(&((x)->fa)))
#define FQ_ISNULL(x) (FA_ISNULL(&((x)->fa)))

extern const char prio[];

#define MAXFLVR(a,b) ((strchr(prio, (a)) < strchr(prio, (b))) ? \
                      (a) : (b))

#endif
