/*
 *  sem.h -- semaphores for multithreaded version
 *
 *  sem.h is a part of binkd project
 *
 *  Copyright (C) 1996  Fydodor Ustinov, FIDONet 2:5020/79
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version. See COPYING.
 */

/*
 * $Id: sem.h,v 1.4 1996/12/29 09:46:30 mff Exp mff $
 *
 * $Log: sem.h,v $
 * Revision 1.4  1996/12/29  09:46:30  mff
 * Misc changes
 *
 * Revision 1.3  1996/12/05  06:56:18  mff
 * Changed to support multiple semaphores
 *
 *
 */

#ifndef _SEM_H_
#define _SEM_H_

#if defined(NT) || defined(W95)

#include <windows.h>
typedef HANDLE MUTEXSEM;

#elif defined(OS2)

#ifdef __WATCOMC__
#define __IBMC__ 0
#define __IBMCPP__ 0
#endif

#define INCL_DOS
#include <os2.h>
typedef HMTX MUTEXSEM;

#endif


/*
 *    Initialise Semaphores.
 */

int _InitSem (void *);

#ifdef HAVE_THREADS
#define InitSem(vpSem) _InitSem(vpSem)
#else
#define InitSem(vpSem)			    /* Do Nothing */
#endif

/*
 *    Clean Semaphores.
 */

int _CleanSem (void *);

#ifdef HAVE_THREADS
#define CleanSem(vpSem) _CleanSem(vpSem)
#else
#define CleanSem(vpSem)			    /* Do Nothing */
#endif

/*
 *    Wait & lock semaphore
 */

int _LockSem (void *);

#ifdef HAVE_THREADS
#define LockSem(vpSem) _LockSem(vpSem)
#else
#define LockSem(vpSem)			    /* Do Nothing */
#endif

/*
 *    Release Semaphore.
 */

int _ReleaseSem (void *);

#ifdef HAVE_THREADS
#define ReleaseSem(vpSem) _ReleaseSem(vpSem)
#else
#define ReleaseSem(vpSem)		    /* Do Nothing */
#endif

#endif
