/*
 *  sys.h -- very system dependent functions and macros
 *
 *  sys.h is a part of binkd project
 *
 *  Copyright (C) 1996  Dima Maloff, 5047/13
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version. See COPYING.
 */

/*
 *  $Id: sys.h,v 1.2 1996/12/29 09:47:18 mff Exp mff $
 *
 *  $Log: sys.h,v $
 * Revision 1.2  1996/12/29  09:47:18  mff
 * Misc changes
 *
 * Revision 1.1  1996/12/14  07:13:04  mff
 * Initial revision
 *
 */

#if defined(NT) || defined(W95)
  #include <windows.h>
  #include <winsock.h>
#endif

#ifdef OS2
  #ifdef __WATCOMC__
    #define __IBMC__ 0
    #define __IBMCPP__ 0
  #endif
  #define INCL_DOS
  #define INCL_ERRORS
  #include <os2.h>
#endif

#ifdef HAVE_THREADS
  #include <dos.h>
  #include <process.h>
  #if defined(OS2)
    int gettid ();
    #define PID() gettid()
  #elif defined(NT)
    #define PID() ((int)GetCurrentThreadId())
  #elif defined(W95)
    #define PID() ((int)(1 - GetCurrentThreadId()))
  #else
    #define PID() ((int)gettid())
  #endif
#else
  #include <sys/wait.h>
  #define PID() ((int)getpid())
#endif

#ifdef UNIX
 /* To be sure rename will fail if the target is exists */
  extern int Rename (char *from, char *to);   /* from unix/Rename.c */
  #define RENAME(f,t) Rename(f,t)
#else
  #define RENAME(f,t) rename(f,t)
#endif

#ifdef HAVE_UNISTD
  #include <unistd.h>
#endif

/*
 * Set up break handler, set up exit list if needed
 */
int set_break_handlers ();

/*
 * Runs a new thread or forks
 */
int branch (void (*) (void *), void *);

#if defined(VISUALCPP)
  #define sleep(a) Sleep(a*1000)
  #define _beginthread(a,b,c,d) _beginthread(a,c,d)
#endif
